{$A+,B-,D+,E-,F-,G+,I-,L+,N-,O-,P-,Q+,R+,S+,T-,V-,X-,Y+}
{$M 12384,0,655360}

uses crt,dos;

const
  outputBufferSize = $FFFF;

type
  byteArray   = array [0..outputBufferSize-1] of byte;
  bytePtr     = ^byteArray;
  _outputFile = object
                 name      : string;
                 handle    : file;
                 opened    : boolean;
                 buf       : bytePtr;
                 bufPtr    : word;
                 overwrite : (ask,never,always);
                 bytes     : longint;
                 procedure create( filename : string );
                 procedure _write;
                 procedure _close;
               end;
  _mainFile   = object
                 name   : string;
                 handle : text;
                 opened : boolean;
                 procedure openFile;
                 procedure closeFile;
               end;
var
  outputFile   : _outputFile;
  mainFile     :  _mainFile;
  filesCounter : word;
  bytesCounter : longint;

const
  rev       :  string[4] = '1.00';

procedure beep; assembler;
asm
  mov ah, 2
  mov dl, 7
  int 21h
end;

procedure error( errorLevel : byte );
begin
  case errorLevel of
    1 : begin
      writeln('   error: no source-file specified.'#13#10);
      writeln('   usage:    BIFI [filename.ext]');
      writeln('              BIFI inbox');
    end;
    2 : writeln('   error: source-file '''+mainFile.name+''' not found.'#13#10);
    3 : writeln('   error: source-file '''+mainFile.name+''' could not be closed.'#13#10);
    4 : writeln('   error: output-file '''+mainFile.name+''' could not be closed.'#13#10);
    5 : writeln('   error: to less memory free.'#13#10);
    6 : writeln('   error: output-file '''+outputFile.name+''' could not be created.'#13#10);
    7 : writeln('   error: output-file '''+outputFile.name+''' could not be accessed.'#13#10);
    8 : writeln('   error: user aborted.'#13#10);
  end;
  beep;
  halt( errorLevel );
end;

procedure quit;
begin
  writeln('   process aborted. ' , filesCounter , ' file(s) / ',bytesCounter,' byte written.');
  halt;
end;

{$I MAINFILE.INC}
{$I OFILE.INC}
{$I INIT.INC}
{$I MAIN.INC}
{$I DONE.INC}

begin
  init;
  main;
  done;
end.